summaryrefslogtreecommitdiffstats
path: root/knot/bin/knot-zones-reset
diff options
context:
space:
mode:
Diffstat (limited to 'knot/bin/knot-zones-reset')
-rwxr-xr-xknot/bin/knot-zones-reset75
1 files changed, 75 insertions, 0 deletions
diff --git a/knot/bin/knot-zones-reset b/knot/bin/knot-zones-reset
new file mode 100755
index 0000000..6471cf4
--- /dev/null
+++ b/knot/bin/knot-zones-reset
@@ -0,0 +1,75 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+HOSTS="${*:-localhost}"
+
+for HOST in ${HOSTS}
+do
+ case "${HOST}" in
+ localhost)
+ echo "Resetting in-memory data for all zones..."
+
+ sudo service knot stop
+
+ sudo rm -rf /var/lib/knot/journal/*.mdb
+ sudo rm -rf /var/lib/knot/timers/*.mdb
+
+ if [ -e /var/lib/knot/zones/.git ]
+ then
+ sudo chown -R root:root /var/lib/knot/zones/
+
+ cd /var/lib/knot/zones
+ sudo git clean -dxf
+ sudo git checkout -f
+
+ sudo chown -R knot:knot /var/lib/knot/zones/
+ fi
+
+ sudo service knot start
+
+ echo
+ echo "done."
+ ;;
+
+ *)
+ echo "'${HOST}': Resetting in-memory data for all zones..."
+
+ ssh "${HOST}" \
+ "sudo service knot stop && \
+ sudo rm -rf /var/lib/knot/journal/*.mdb && \
+ sudo rm -rf /var/lib/knot/timers/*.mdb && \
+ if [ -e /var/lib/knot/zones/.git ]; \
+ then \
+ sudo chown -R root:root /var/lib/knot/zones/; \
+ cd /var/lib/knot/zones; \
+ sudo git clean -dxf; \
+ sudo git checkout -f; \
+ sudo chown -R knot:knot /var/lib/knot/zones/; \
+ fi; \
+ sudo service knot start"
+
+ echo
+ echo "done."
+ ;;
+ esac
+done